<?php

/*
+==========================================================================+
| Admin Secure Version Upgrade                                             |
| Version 1.2                                                              |
| Copyright (c) 2003-2004 Madman                                           |
| http://gp4tweaker.vadertrophy.com                                        |
+--------------------------------------------------------------------------+
| Disclaimer: You run this package at your sole risk. Author cannot be     |
| held liable if anything goes wrong. You are advised to test this package |
| on a development system. Backup everything before implementing in a      |
| production environment. If something goes wrong, you can always backout  |
| and restore your backups.                                                |
|                                                                          |
| Terms and Conditions: Installing and running this also means you agree   |
| to the terms of usages and conditions to this package. As always, make   |
| a backup before messing with anything. All code release by me is         |
| considered sample code only. It may be fully functual, but you use it    |
| at your own risk, if you break it, you get to fix it too. No waranty is  |
| given or implied. All original header code and copyright messages        |
| will be maintained to give credit where credit is due. If you modify     |
| this, the only requirement is that you also maintain all original        |
| copyright messages. Released under GNU/General Public License.           |
|                                                                          |
| This program is free software; you can redistribute it and/or modify     |
| it under the terms of the GNU General Public License as published by     |
| the Free Software Foundation; either version 2 of the License, or        |
| (at your option) any later version.                                      |
+==========================================================================+
*/

//error_reporting(E_ALL ^ E_NOTICE);

require_once("mainfile.php");
require_once("includes/asfunc.php");

$index = 0;
$scriptname = basename($_SERVER['PHP_SELF']);

function asec_menuDetectInstall() {
	global $db;
	include("includes/asconfig.php");
	$result = $db->sql_query("SELECT 1 FROM ".$asec_dbtable." LIMIT 0");
	return ($result) ? 1 : 0;
}

function asec_menuMain($title = "") {
	OpenTable();
	echo "<center>"
	."<font class=\"title\"><b>Admin Secure Upgrade</b></font>\n";
	if ($title != "") {
		echo "<br><br><font class=\"content\">$title</font>\n";
	}
	echo "</center>\n";
	CloseTable();
	echo "<br>\n";
}

function asec_menuAccessDenied() {
	OpenTable();
	echo "<center>\n"
	."<font class=\"title\"><b>Access Denied</b></font><br><br>\n"
	."<font class=\"content\">Sorry, this is a restricted area.</font>\n"
	."</center>\n";
	CloseTable();
}

function asec_menuUpgrade() {
	global $admin, $db;
	if (asec_menuDetectInstall()) {
		asec_menuMain("Perform Upgrade Installation");
		include("includes/asconfig.php");
		$dberror = 0;
		$upgrade = 0;

		$result = $db->sql_query("SELECT 1 FROM ".$asec_dbconfig." LIMIT 0");
		if (!$result) {

			/* upgrade from 1.0 to latest version */

			$sql = "CREATE TABLE ".$asec_dbconfig." ("
				."asc_name varchar(255) NOT NULL default '', "
				."asc_value varchar(255) NOT NULL default '', "
				."PRIMARY KEY (asc_name) "
				.") TYPE=MyISAM";
			$dberror += ($db->sql_query($sql)) ? 0 : 1;
			if ($dberror == 0) {
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('check_time', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('check_days', '1')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('last_check', '".sprintf("%u", time())."')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('admin_mail_address', 'yourname@yoursite.com')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('send_notify_mail_to', 'yourname@yoursite.com')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('auto_sync', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_dbquery_vars', '1')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_admin_var', '1')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_extern_file', '1')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_script_vars', '1')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_check', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_account_change', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_dbquery_vars', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_admin_var', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_extern_file', '0')")) ? 0 : 1;
				$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_script_vars', '0')")) ? 0 : 1;
				$upgrade = 1;
			}
		} else {

			/* upgrade from 1.1 to latest version */

			$dberror += ($result = $db->sql_query("SELECT asc_value FROM ".$asec_dbconfig." WHERE asc_name='filter_script_vars' LIMIT 1")) ? 0 : 1;
			if ($dberror == 0) {
				$row = $db->sql_fetchrow($result);
				if (!isset($row['asc_value'])) {
					$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_script_vars', '1')")) ? 0 : 1;
					$dberror += ($db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_script_vars', '0')")) ? 0 : 1;
					$upgrade = 1;
				}
			}
		}

		OpenTable();
		echo "<center>"
		."<font class=\"content\">";
		if ($dberror == 0) {
			if ($upgrade) {
				echo "Upgrade installation has been done successfully.<br>"
				."You may consider to adjust configuration settings from Admin Secure Administration Panel.<br>"
				."Be sure to delete this upgrade script from your PHP-Nuke root directory as soon as possible.<br><br>";

				$rcode = asec_createRecallCode($admin);
				echo "Below are two security codes that will be asked on emergency situations.<br>"
				."Write down these codes and stored in the safe place.<br><br>\n"
				."<table border=\"0\" cellpadding=\"0\" cellspacing=\"5\">\n"
				."<tr><td align=\"right\"><font class=\"content\">Authorization Code:</font></td><td align=\"left\"><font class=\"content\"><b>$rcode[auth]</b></font></td></tr>\n"
				."<tr><td align=\"right\"><font class=\"content\">Key Activation Code:</font></td><td align=\"left\"><font class=\"content\"><b>$rcode[code]</b></font></td></tr>\n"
				."</table>\n";
			} else {
				echo "You are currently using the latest version of Admin Secure.<br>"
				."There is not necessary to perform version upgrade now.<br><br>"
				."<b>Please delete this upgrade script from your PHP-Nuke root directory.</b>";
			}
		} else {
			echo "Unable to perform upgrade installation!<br>"
			."An error was occured while attempting to accessing your database.<br>"
			."Be sure your PHP-Nuke and database settings are configured properly, then re-run this script again.";
		}
		echo "</font></center>\n";
		CloseTable();
	} else {
		asec_menuMain("Admin Secure Not Installed");
		OpenTable();
		echo "<center>"
		."<font class=\"content\">"
		."Admin Secure not yet installed on this system.<br>"
		."Please read the documentation to perform Admin Secure full installation."
		."</font></center>\n";
		CloseTable();
	}
}

include("header.php");
if (asec_isAdmin($admin) && asec_isGodAdmin($admin)) {
	asec_menuUpgrade();
} else {
	asec_menuAccessDenied();
}
include("footer.php");

?>
